<?php
//GET

//PRODUCTS
//list of all products
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/products', [
        'methods' => 'GET',
        'callback' => 'apiGetProductsList',
    ]);
} );
//product with specific id (details)
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/products/(?P<id>\d+)', [
        'methods' => 'GET',
        'callback' => 'apiGetProductDetails',
    ]);
} );
//product categories
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/products/categories', [
        'methods' => 'GET',
        'callback' => 'apiGetCategoriesList'//'categories',
    ]);
} );
//list products by category
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/products/categories/(?P<id>\d+)/products', [
        'methods' => 'GET',
        'callback' => 'apiGetProductsByCategory',
    ]);
} );
//get top ${topLimit} products by category
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/products/categories/(?P<id>\d+)/products/(?P<limit>\d+)', [
        'methods' => 'GET',
        'callback' => 'apiGetTopProductsByCategory',
    ]);
} );
//get products by vendor id
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/vendor/(?P<id>\d+)/products', [
        'methods' => 'GET',
        'callback' => 'apiGetProductsByVendor',
    ]);
} );
//get order details
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/orders/(?P<id>\d+)', [
        'methods' => 'GET',
        'callback' => 'apiGetOrderDetails',
    ]);
} );
//get orders list
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/orders', [
        'methods' => 'GET',
        'callback' => 'apiGetOrdersList',
    ]);
} );
//get payment methods
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/payment_gateways', [
        'methods' => 'GET',
        'callback' => 'apiGetPaymentMethods',
    ]);
} );
//get shipping methods
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/shipping_methods', [
        'methods' => 'GET',
        'callback' => 'apiGetShippingMethods',
    ]);
} );

//POST
//make an order
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/orders', [
        'methods' => 'POST',
        'callback' => 'apiMakeAnOrder',
    ]);
} );

//init payment
add_action( 'rest_api_init', function () {
    register_rest_route( 'wc-expay/v1', '/payment', [
        'methods' => 'POST',
        'callback' => 'apiProcessPayment',
    ]);
} );
